Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# GT2005BasicBehaviorGoToPointAndAvoidObstacles Class Reference

A Basic Behavior for going to a point on the field and avoiding obstacles on the way there. More...

`#include <GT2005SimpleBasicBehaviors.h>`

Inheritance diagram for GT2005BasicBehaviorGoToPointAndAvoidObstacles:

[legend]
Collaboration diagram for GT2005BasicBehaviorGoToPointAndAvoidObstacles:

[legend]
List of all members.

## Public Member Functions
| GT2005BasicBehaviorGoToPointAndAvoidObstacles (BehaviorControlInterfaces &interfaces, Xabsl2ErrorHandler &errorHandler)
virtual void | execute ()
| Executes the basic behavior.
## Private Attributes
double | x
| parameter "go-to-point-and-avoid-obstacles.x"
double | y
| parameter "go-to-point-and-avoid-obstacles.y"
double | maxSpeed
| parameter "go-to-point-and-avoid-obstacles.max-speed"
double | avoidanceLevel
| parameter "go-to-point-and-avoid-obstacles.avoid-penalty-areas"
PIDsmoothedValue | turnSpeed
| smoothes the rotation
PIDsmoothedValue | speedX
| smoothes the speed in forward direction
PIDsmoothedValue | speedY
| smoothes the speed in sideways direction
long | lastTimeExecuted
| last time behavior was executed

## Detailed Description

A Basic Behavior for going to a point on the field and avoiding obstacles on the way there.

Author:
  Jan Hoffmann

Definition at line 819 of file GT2005SimpleBasicBehaviors.h.

## Constructor & Destructor Documentation

GT2005BasicBehaviorGoToPointAndAvoidObstacles::GT2005BasicBehaviorGoToPointAndAvoidObstacles | ( | BehaviorControlInterfaces & | interfaces,
|  | Xabsl2ErrorHandler & | errorHandler
| ) | `[inline]`

| Definition at line 827 of file GT2005SimpleBasicBehaviors.h. References avoidanceLevel, pi, point, Xabsl2BasicBehavior::registerParameter(), and turnSpeed.

Here is the call graph for this function:

## Member Function Documentation

void GT2005BasicBehaviorGoToPointAndAvoidObstacles::execute | ( |  | ) | `[virtual]`

| Executes the basic behavior. Implements Xabsl2BasicBehavior. Definition at line 708 of file GT2005SimpleBasicBehaviors.cpp. References Geometry::angleTo(), PIDsmoothedValue::approximateVal(), Geometry::distanceTo(), ObstaclesModel::getAngleOfNextFreeSector(), SystemCall::getCurrentSystemTime(), ObstaclesModel::getDistanceInCorridor(), RobotPose::getPose(), SystemCall::getTimeSince(), ObstaclesModel::getTotalFreeSpaceInSector(), lastTimeExecuted, MotionRequest::motionType, pi, Range< T >::Range(), PIDsmoothedValue::resetTo(), Pose2D::rotation, Pose2D::translation, turnSpeed, WalkRequest::walkParams, MotionRequest::walkRequest, WalkRequest::walkType, Vector2< double >::x, and Vector2< double >::y.

Here is the call graph for this function:

## Member Data Documentation

double GT2005BasicBehaviorGoToPointAndAvoidObstacles::x`[private]`

| parameter "go-to-point-and-avoid-obstacles.x" Definition at line 846 of file GT2005SimpleBasicBehaviors.h.

double GT2005BasicBehaviorGoToPointAndAvoidObstacles::y`[private]`

| parameter "go-to-point-and-avoid-obstacles.y" Definition at line 849 of file GT2005SimpleBasicBehaviors.h.

double GT2005BasicBehaviorGoToPointAndAvoidObstacles::maxSpeed`[private]`

| parameter "go-to-point-and-avoid-obstacles.max-speed" Definition at line 852 of file GT2005SimpleBasicBehaviors.h.

double GT2005BasicBehaviorGoToPointAndAvoidObstacles::avoidanceLevel`[private]`

| parameter "go-to-point-and-avoid-obstacles.avoid-penalty-areas" Definition at line 855 of file GT2005SimpleBasicBehaviors.h. Referenced by GT2005BasicBehaviorGoToPointAndAvoidObstacles().

PIDsmoothedValue GT2005BasicBehaviorGoToPointAndAvoidObstacles::turnSpeed`[private]`

| smoothes the rotation Definition at line 858 of file GT2005SimpleBasicBehaviors.h. Referenced by execute(), and GT2005BasicBehaviorGoToPointAndAvoidObstacles().

PIDsmoothedValue GT2005BasicBehaviorGoToPointAndAvoidObstacles::speedX`[private]`

| smoothes the speed in forward direction Definition at line 861 of file GT2005SimpleBasicBehaviors.h.

PIDsmoothedValue GT2005BasicBehaviorGoToPointAndAvoidObstacles::speedY`[private]`

| smoothes the speed in sideways direction Definition at line 864 of file GT2005SimpleBasicBehaviors.h.

long GT2005BasicBehaviorGoToPointAndAvoidObstacles::lastTimeExecuted`[private]`

| last time behavior was executed Definition at line 867 of file GT2005SimpleBasicBehaviors.h. Referenced by execute().

The documentation for this class was generated from the following files:

- Modules/BehaviorControl/GT2005BehaviorControl/GT2005BasicBehaviors/GT2005SimpleBasicBehaviors.h
- Modules/BehaviorControl/GT2005BehaviorControl/GT2005BasicBehaviors/GT2005SimpleBasicBehaviors.cpp